<template>
  <div class="m-container">
    <h2>
      <el-page-header @back="onCancel"
                      content="VIP课申请"></el-page-header>
      <!-- <div class="squrt" /> -->
    </h2>
    <div class="m-core">
      <div class="vipLeft">
        <h4>课程信息</h4>
        <el-form ref="leftForm"
                 :rules="leftFormRules"
                 :label-position="labelPosition"
                 label-width="110px"
                 :model="leftForm">
          <!-- <el-form-item label="课程名称" prop="name">
            <el-input v-model.trim="leftForm.name" />
          </el-form-item> -->
          <el-form-item label="科目名称"
                        prop="subject">
            <el-select v-model.trim="leftForm.subject"
                       filterable
                       clearable
                       @change="changeSubject">
              <el-option v-for="(item,index) in subjectList"
                         :key="index"
                         :value="item.id"
                         :label="item.name" />
            </el-select>
          </el-form-item>
          <el-form-item label="指导老师"
                        prop="teacher">
            <el-select v-model.trim="leftForm.teacher"
                       filterable
                       clearable
                       :disabled="!leftForm.subject"
                       @change="setSection($event)">
              <el-option v-for="(item,index) in teacherList"
                         :key="index"
                         :label="item.realName"
                         :value="item.id" />
            </el-select>
          </el-form-item>
          <el-form-item label="乐团主管"
                        prop="educationalTeacherId">
            <el-select v-model.trim="leftForm.educationalTeacherId"
                       filterable
                       clearable
                       :disabled="!leftForm.subject"
                       @change="getClassOrgan()">
              <el-option v-for="(item,index) in educationList"
                         :key="index"
                         :label="item.userName"
                         :value="item.userId" />
            </el-select>
          </el-form-item>
          <el-form-item label="课程分部"
                        prop="classOrganId">
            <el-select v-model.trim="leftForm.classOrganId"
                       filterable
                       clearable
                       :disabled="!leftForm.teacher || !leftForm.educationalTeacherId"
                       @change="onClassChange">
              <el-option v-for="(item,index) in classOrganList"
                         :key="index"
                         :label="item.name"
                         :value="item.id" />
            </el-select>
          </el-form-item>

          <el-form-item label="课程形式"
                        prop="courseType">
            <el-select v-model.trim="leftForm.courseType"
                       clearable
                       filterable
                       :disabled="!leftForm.classOrganId"
                       @change="changeType">
              <el-option v-for="(item,index) in courseTypeList"
                         :key="index"
                         :label="item.name"
                         :value="item.id" />
            </el-select>
          </el-form-item>
          <el-form-item label="上课学生"
                        prop="students">
            <el-select v-model.trim="leftForm.students"
                       multiple
                       clearable
                       placeholder="请输入上课学生"
                       remote
                       reserve-keyword
                       filterable
                       :multiple-limit="studentLimit"
                       :disabled="!leftForm.classOrganId || !leftForm.courseType"
                       :remote-method="remoteMethod"
                       :loading="remoteLoading">
              <el-option v-for="(item,index) in studentList"
                         :key="item.userId"
                         :label="item.username"
                         :value="item.userId">
                <span style="float: left">{{ item.username }}</span>
                <span style="float: right; color: #8492a6; font-size: 13px">{{item.parentsPhone }}</span>
              </el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="活动方案"
                        prop="activeType">
            <el-select v-model.trim="leftForm.activeType"
                       filterable
                       clearable
                       :disabled="!leftForm.courseType"
                       @change="chioseActive">
              <el-option v-for="(item,index) in activeList"
                         :key="index"
                         :value="item.id"
                         :label="item.name" />
            </el-select>
          </el-form-item>
          <!-- 11111111111111111111111111111111 -->
          <el-form-item label="教学点">
            <el-select v-model.trim="leftForm.section"
                       filterable
                       clearable
                       :disabled="!leftForm.teacher">
              <el-option v-for="(item,index) in scetionList"
                         :key="index"
                         :value="item.id"
                         :label="item.name" />
            </el-select>
          </el-form-item>
          <el-form-item label="每班人数">
            <el-input type="number"
                      @mousewheel.native.prevent
                      v-model.trim="leftForm.classNum"
                      disabled />
          </el-form-item>
          <el-form-item label="每课时长">
            <!-- <el-input type="number"
                      v-model.trim="leftForm.classTime"
            disabled />-->
            <el-select v-model.trim="leftForm.classTime"
                       :disabled="timeTable.length>0">
              <el-option v-for="(item,index) in this.classTimeList"
                         :key="index"
                         :value="item"
                         :label="item"></el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="
                       报名开始时间"
                        prop="signUpStart">
            <!-- @change="changeStartTime" -->
            <el-date-picker v-model.trim="leftForm.signUpStart"
                            type="date"
                            :picker-options="pickerOptions"
                            value-format="yyyy-MM-dd HH:mm:ss"
                            placeholder="请选择时间" />
          </el-form-item>
          <el-form-item label="报名结束时间"
                        prop="signUpEnd">
            <el-date-picker v-model.trim="leftForm.signUpEnd"
                            type="date"
                            :picker-options="pickerOptions1"
                            value-format="yyyy-MM-dd HH:mm:ss"
                            placeholder="请选择时间" />
          </el-form-item>
          <el-form-item v-if="leftForm.courseStart"
                        label="最早排课时间">
            <el-date-picker v-model.trim="leftForm.courseStart"
                            disabled
                            type="date"
                            value-format="yyyy-MM-dd HH:mm:ss"
                            placeholder="请选择时间" />
          </el-form-item>
          <el-form-item v-if="leftForm.courseEnd"
                        label="最晚排课时间">
            <el-date-picker v-model.trim="leftForm.courseEnd"
                            disabled
                            type="date"
                            value-format="yyyy-MM-dd HH:mm:ss"
                            placeholder="请选择时间" />
          </el-form-item>
        </el-form>
      </div>
      <div class="center">
        <h4>排课设置</h4>
        <el-form :model="centerForm"
                 label-width="100px"
                 :label-position="labelPosition">
          <el-form-item v-if="hasOnline"
                        label="线上课数">
            <el-input v-model.trim="centerForm.onlineCourseNum"
                      @mousewheel.native.prevent
                      type="number" />
          </el-form-item>
          <el-form-item v-if="hasOffline"
                        label="线下课数">
            <el-input v-model.trim="centerForm.offlineCourseNum"
                      @mousewheel.native.prevent
                      type="number" />
          </el-form-item>
          <el-form-item label="待排课数">
            <el-input v-model.trim="allCourseCount"
                      disabled />
          </el-form-item>
          <el-form-item v-if="hotType=='GIVE_CLASS'&&isGiveClass"
                        label="赠课课程类型">
            <el-radio v-model.trim="centerForm.radio"
                      label="ONLINE">线上课</el-radio>
            <el-radio v-model.trim="centerForm.radio"
                      label="OFFLINE">线下课</el-radio>
          </el-form-item>
        </el-form>
        <!-- 排课列表开始 -->
        <div class="planList">
          <div class="planTop">
            <p>已排课程</p>
            <el-button type="text"
                       @click="setCourse">{{id?'新增排课':'点击排课'}}</el-button>
          </div>
          <div class="planCore">
            <div class="row">
              <div class="name">时间</div>
              <div class="week">开始时间</div>
              <div class="time">结束时间</div>
              <div class="time">课程类型</div>
            </div>
            <div v-for="(item,index) in this.timeTable"
                 :key="index"
                 class="row">
              <div class="name">{{ item.classDate | formatTimer }}</div>
              <div class="week">{{ item.startClassTimeStr }}</div>
              <div class="time">{{ item.endClassTimeStr }}</div>
              <div class="time">{{ item.teachMode |teachMode }}</div>
            </div>
          </div>
        </div>
      </div>
      <div class="right">
        <h4>课酬设置</h4>
        <el-form :model="rightForm"
                 label-width="100px"
                 :label-position="labelPosition">
          <el-form-item v-if="hasOnline"
                        label="线上课课酬">
            <el-input v-model.trim="rightForm.onlineCourse"
                      :disabled="true" />
            <!--  || onlineSalary!='TEACHER_DEFAULT' salaryReadonlyFlag==0 -->
          </el-form-item>
          <el-form-item v-if="hasOffline"
                        label="线下课课酬">
            <el-input v-model.trim="rightForm.offlineCourse"
                      :disabled="true" />
            <!--  || offlineSalary!='TEACHER_DEFAULT' salaryReadonlyFlag==0 -->
          </el-form-item>
          <el-form-item v-if="hasOnline"
                        label="线上课单价">
            <el-input v-model.trim="rightForm.onlinePrice"
                      :disabled="paymentReadonlyFlag==0" />
          </el-form-item>
          <el-form-item v-if="hasOffline"
                        label="线下课单价">
            <el-input v-model.trim="rightForm.offlinePrice"
                      :disabled="paymentReadonlyFlag==0" />
          </el-form-item>
          <el-form-item label="课程总价">
            <el-input v-model.trim="rightForm.allPrice"
                      disabled />
          </el-form-item>
        </el-form>
        <el-button type="primary"
                   style="float:right"
                   @click="computational">计算</el-button>
      </div>
    </div>
    <!-- 弹窗 -->
    <el-dialog title="VIP排课"
               ref="maskForm"
               width="500px"
               destroy-on-close
               :visible.sync="dialogFormVisible">
      <el-form :model="maskForm"
               label-position="right"
               label-width="150px">
        <el-form-item label="线上课开课时间">
          <el-date-picker v-model.trim="maskForm.courseStartOnline"
                          type="date"
                          :picker-options="courseOption"
                          placeholder="请选择开课时间" />
        </el-form-item>
        <el-form-item label="线下课开课时间">
          <el-date-picker v-model.trim="maskForm.courseStartOffline"
                          type="date"
                          :picker-options="courseOption"
                          placeholder="请选择开课时间" />
        </el-form-item>
        <div class="line"
             style="height:1px; background:#ccc; margin:0 25px;"></div>
        <el-form-item label="课程类型"
                      prop="type">
          <el-radio v-if="hasOnline"
                    v-model.trim="maskForm.type"
                    label="ONLINE">线上课</el-radio>
          <el-radio v-if="hasOffline"
                    v-model.trim="maskForm.type"
                    label="OFFLINE">线下课</el-radio>
        </el-form-item>
        <el-form-item label="循环周次"
                      prop="week">
          <el-select v-model.trim="maskForm.week"
                     style="width:220px!important;">
            <el-option label="星期日"
                       value="0" />
            <el-option label="星期一"
                       value="1" />
            <el-option label="星期二"
                       value="2" />
            <el-option label="星期三"
                       value="3" />
            <el-option label="星期四"
                       value="4" />
            <el-option label="星期五"
                       value="5" />
            <el-option label="星期六"
                       value="6" />
          </el-select>
        </el-form-item>
        <el-form-item label="上课时间"
                      prop="startTime">
          <el-time-picker v-model.trim="maskForm.startTime"
                          @change="getStartTime"
                          format="HH:mm"
                          value-format="HH:mm"
                          placeholder="选择时间" />
        </el-form-item>
        <el-form-item label="下课时间"
                      prop="endTime">
          <el-time-picker v-model.trim="maskForm.endTime"
                          disabled
                          format="HH:mm"
                          value-format="HH:mm"
                          :picker-options="{
                            start: '04:30',
                            step: '00:05',
                            end: '23:30'
                            }"
                          placeholder="选择时间" />
        </el-form-item>
      </el-form>
      <div class="btnWrap">
        <div class="okBtn"
             @click="addWeek">确认</div>
      </div>

      <div class="planList">
        <div class="planTop">
          <p>已排课程</p>
        </div>
        <div class="planCore">
          <div v-for="(item,index) in this.lookList"
               class="row"
               :key="index">
            <div class="name">{{ item.type }}</div>
            <div class="week">{{ item.week }}</div>
            <div class="time">{{ item.time }}</div>
            <div class="operation">
              <el-button type="text"
                         @click="removeWeekCourse(item.id)">删除</el-button>
            </div>
          </div>
        </div>
        <div slot="footer"
             style="margin-top:20px;"
             class="dialog-footer">
          <el-button @click="dialogFormVisible = false">取 消</el-button>
          <el-button type="primary"
                     @click="setTimeTable">确 定</el-button>
        </div>
      </div>
    </el-dialog>
    <div class="btnWrap">
      <!-- <div class="closeBtn">
        取消
      </div>-->
      <div class="okBtn"
           @click="submitInfo">{{id?'修改':'确定'}}</div>
    </div>
  </div>
</template>
<script>
import {
  findTeacherByOrganId,
  getSubject,
  findEducationUsers
} from "@/api/buildTeam";
import {
  vipGroupCategory,
  vipGroupActivityFind,
  getVipGroupCostCount,
  createVip,
  getVipGroupDetail,
  updateVipBaseInfo,
  getPublicOrgans,
} from "@/api/vipSeting";
import {
  getTeachSchool,
  getTeacherBySubject
} from "@/api/teacherManager";
import {
  queryStudentList
} from "@/api/studentManager";
import axios from "axios";
import {
  getToken
} from "@/utils/auth";
import { diffTimerFormMinute, addTimerFormMinute } from '@/utils/date'
import dayjs from 'dayjs';
export default {
  name: "buildVip",
  data () {
    return {
      dialogFormVisible: false,
      labelPosition: "right",
      leftForm: {
        // name: "",
        teacher: "",
        subject: "",
        courseType: "",
        activeType: "",
        classNum: "",
        classTime: "",
        signUpStart: "",
        signUpEnd: "",
        courseStartOnline: "",
        courseStartOffline: "",
        courseEnd: "",
        section: "",
        courseStart: "",
        courseEnd: "",
        educationalTeacherId: "",
        students: [],
        classOrganId: "" // 课程分部
      },
      studentLimit: 0,
      classTimeList: [],
      centerForm: {
        allCourseNum: "",
        onlineCourseNum: 0,
        offlineCourseNum: 0,
        radio: ""
      },
      maskForm: {
        type: "",
        week: "",
        startTime: "",
        endTime: ''
      },
      rightForm: {
        onlineCourse: "",
        offlineCourse: "",
        onlinePrice: "",
        offlinePrice: "",
        allPrice: ""
      },
      remoteLoading: false,
      computationalBtn: false,
      subjectList: [], // 科目列表
      teacherList: [], // 老师列表
      educationList: [], // 教务
      classOrganList: [], // 公用分部
      courseTypeList: [], // 课程类型集合
      activeList: [], //活动集合
      hasOnline: false,
      hasOffline: false,
      onlineSalary: "", // 线上课课酬结算方式
      offlineSalary: "", // 线下课课酬结算方式
      hotType: "",
      attribute1: "",
      attribute2: "",
      salaryReadonlyFlag: "", // 老师课酬是否可配
      paymentReadonlyFlag: "", // 课程单价是否可配
      lookList: [],
      onlinelookList: [], // 展示课表线上
      offlineLookList: [], // 展示课表线下
      timeTable: [], // 真正的课表
      giveNum: "",
      weekDay: [
        "星期日",
        "星期一",
        "星期二",
        "星期三",
        "星期四",
        "星期五",
        "星期六"
      ],
      scetionList: [],
      isGiveClass: false,
      activeStartTime: null,
      courseOption: null,
      pickerOptions: null,
      pickerOptions1: null,
      leftFormRules: {
        /**?
         * teacher: '',
        subject: '',
        courseType: '',
        activeType: '',
         */
        name: [{
          required: true,
          message: "请输入名称",
          trigger: "blur"
        }],
        teacher: [{
          required: true,
          message: "请选择老师",
          trigger: "change"
        }],
        educationalTeacherId: [{
          required: true,
          message: "请选择教务",
          trigger: "change"
        }],
        classOrganId: [{
          required: true,
          message: "请选择课程分部",
          trigger: "change"
        }],
        subject: [{
          required: true,
          message: "请选择科目",
          trigger: "change"
        }],
        courseType: [{
          required: true,
          message: "请选择课程类型",
          trigger: "change"
        }],
        students: [{
          required: true,
          message: "请选择上课学生",
          trigger: "change"
        }],
        activeType: [{
          required: true,
          message: "请选择活动",
          trigger: "change"
        }],
        signUpStart: [{
          required: true,
          message: "请选择报名开始时间",
          trigger: "change"
        }],
        signUpEnd: [{
          required: true,
          message: "请选择报名结束时间",
          trigger: "change"
        }]
      },
      id: "",
      studentList: [],
      courseTimeList: []
    };
  },
  computed: {
    allCourseCount () {
      let online, offline;
      this.centerForm.onlineCourseNum ?
        (online = this.centerForm.onlineCourseNum) :
        (online = 0);
      this.centerForm.offlineCourseNum ?
        (offline = this.centerForm.offlineCourseNum) :
        (offline = 0);
      let giveNum;
      if (this.hotType == "GIVE_CLASS") {
        //  this.attribute1  从多少节开始送
        //  this.attribute2  送多少节
        giveNum = parseInt(
          parseInt(offline) + parseInt(online) - this.attribute1 >= 0 ?
            (giveNum = this.attribute2) :
            (giveNum = 0)
        );
        if (giveNum) {
          // 有赠送课时
          this.isGiveClass = true;
        }
        this.giveNum = giveNum || 0;

        return parseInt(offline) + parseInt(online) + "+" + giveNum || "";
      }
      return parseInt(offline) + parseInt(online) || "";
    }
  },
  created () {
    // 如果有id则是修改  带出所有的数据
    // 没有id 则是新增
    // this.id = this.$route.query.id;

    // if (this.id) {
    //   // 发请求获取信息
    //   getVipGroupDetail({ vipGroupId: this.id }).then(res => {
    //     if (res.code == 200) {
    //       this.setVipInfo(res.data);
    //     }
    //   });
    // }
    // this.init();
  },
  mounted () {
    // 获取所有老师的接口  根据声部id获取老师
    // 获取课程类型的接口
    // 获取学生列表
    // queryStudentList({ rows: 100000 }).then(res => {
    //   if (res.code == 200) {
    //     this.studentList = res.data.rows
    //   }
    // })
    Object.assign(this.$data, this.$options.data());
    setTimeout(() => {
      this.$refs["leftForm"].resetFields();
    }, 100);
    this.init();

  },
  activated () {
    Object.assign(this.$data, this.$options.data());
    setTimeout(() => {
      this.$refs["leftForm"].resetFields();
    }, 100);
    this.init();
  },
  methods: {
    init () {
      if (this.$route.query.rules) {
        this.rules = this.$route.query.rules;
      }
      if (this.$route.query.searchForm) {
        this.searchForm = this.$route.query.searchForm;
      }
      // 获取所有科目的接口
      getSubject({
        tenantId: 1
      }).then(res => {
        if (res.code == 200) {
          this.subjectList = res.data;
        }
      });

      //  获取乐团主管
      findEducationUsers({}).then(res => {
        if (res.code == 200) {
          this.educationList = res.data;
        }
      });
      this.pickerOptions = this.beginDate();
      this.pickerOptions1 = this.processDate();
      this.courseOption = this.coursesDate();
    },
    coursesDate () {
      let self = this;
      return {
        firstDayOfWeek: 1,
        disabledDate: time => {
          if (self.leftForm.courseStart) {
            let date = new Date(self.leftForm.courseStart.replace(/-/, "/"));
            return time.getTime() < date.getTime();
          }
          return;
        }
      };
    },
    beginDate () {
      let self = this;
      return {
        firstDayOfWeek: 1,
        disabledDate (time) {
          return time.getTime() + 86400000 <= new Date().getTime(); //开始时间不选时，结束时间最大值小于等于当天
        }
      };
    },
    processDate () {
      //提出结束时间必须大于提出开始时间
      let self = this;
      return {
        firstDayOfWeek: 1,
        disabledDate (time) {
          if (self.leftForm.signUpStart) {
            return (
              new Date(self.leftForm.signUpStart).getTime() > time.getTime()
            );
          } else {
            return time.getTime() > Date.now();
            //开始时间不选时，结束时间最大值小于等于当天
          }
        }
      };
    },
    changeSubject (val) {
      this.leftForm.teacher = "";
      this.leftForm.section = "";
      // 根据科目id获取相应的老师
      findTeacherByOrganId({
        subjectIds: val
      }).then(res => {
        if (res.code == 200) {
          this.teacherList = res.data;
        }
      });
      // getTeacherBySubject({ subjecId: val }).then(res => {
      //   if (res.code == 200) {
      //     this.teacherList = res.data;
      //   }
      // })
    },
    // 选择课程类型
    changeType (val) {
      // 在这里清空默认课酬
      this.rightForm.offlineCourse = "";
      this.rightForm.onlineCourse = "";
      this.leftForm.activeType = "";
      this.leftForm.students = [] // 重置所选学生
      for (let i in this.courseTypeList) {
        if (this.courseTypeList[i].id == val) {
          // 学生人数
          this.leftForm.classNum = this.courseTypeList[i].studentNum;
          this.studentLimit = this.courseTypeList[i].studentNum
          // 每课时长
          this.classTimeList = this.courseTypeList[i].singleClassMinutes.split(
            ","
          );
          // this.leftForm.classTime = this.courseTypeList[i].singleClassMinutes;
          this.leftForm.classTime = this.classTimeList[0];
          // 线上课单节价格
          this.rightForm.onlinePrice = this.courseTypeList[
            i
          ].onlineClassesUnitPrice;
          // 线下课单节价格
          this.rightForm.offlinePrice = this.courseTypeList[
            i
          ].offlineClassesUnitPrice;
        }
      }
      // teacherId

      if (this.leftForm.courseType) {
        // 根据课程类型获取活动方案
        vipGroupActivityFind({
          categoryId: this.leftForm.courseType,
          teacherId: this.leftForm.teacher
        }).then(res => {
          if (res.code == 200) {
            this.activeList = res.data;
          }
        });
      }

    },
    // 选择活动方案
    chioseActive (val) {
      this.rightForm.offlineCourse = "";
      this.rightForm.onlineCourse = "";
      // this.rightForm.onlinePrice = '';
      // this.rightForm.offlinePrice = '';
      this.lookList = [];
      this.timeTable = [];
      this.attribute1 = "";
      this.attribute2 = "";
      this.giveNum = 0;
      this.isGiveClass = false;
      // 重置课程单价
      for (let i in this.courseTypeList) {
        if (this.courseTypeList[i].id == this.leftForm.courseType) {
          // 学生人数
          this.leftForm.classNum = this.courseTypeList[i].studentNum;
          // 每课时长
          this.classTimeList = this.courseTypeList[i].singleClassMinutes.split(
            ","
          );
          // this.leftForm.classTime = this.courseTypeList[i].singleClassMinutes;
          this.leftForm.classTime = this.classTimeList[0];
          // 线上课单节价格
          this.rightForm.onlinePrice = this.courseTypeList[
            i
          ].onlineClassesUnitPrice;
          // 线下课单节价格
          this.rightForm.offlinePrice = this.courseTypeList[
            i
          ].offlineClassesUnitPrice;
        }
      }
      // 根须活动id获取 相应的值
      for (let i in this.activeList) {
        if (this.activeList[i].id == val) {
          // 如果是买赠就必须选择赠课类型
          // 报名开始 报名结束 课程开始 课程结束 // 判断是否有线上,线下课 并同步状态
          // this.leftForm.signUpStart = this.activeList[i].startTime;
          // this.leftForm.signUpEnd = this.activeList[i].endTime;
          this.leftForm.courseStart = this.activeList[i].coursesStartTime;
          this.leftForm.courseEnd = this.activeList[i].coursesEndTime;
          // 获取活动种类并保存
          this.hotType = this.activeList[i].type;
          // 获取买赠必要参数
          this.attribute1 = this.activeList[i].attribute1;
          this.attribute2 = this.activeList[i].attribute2;
          // 存储课酬是否可配置
          this.salaryReadonlyFlag = this.activeList[i].salaryReadonlyFlag;
          this.paymentReadonlyFlag = this.activeList[i].paymentReadonlyFlag;
          //  hasOnline: false, hasOffline: false 还需要判断type类型 根据活动id获取
          if (this.activeList[i].salarySettlementJson) {
            let obj = JSON.parse(this.activeList[i].salarySettlementJson);
            if (obj && obj.onlineSalarySettlement) {
              // 有线上课
              this.hasOnline = true;
              this.onlineSalary =
                obj.onlineSalarySettlement.salarySettlementType;
              // console.log('线上:' + this.onlineSalary)
            } else {
              this.hasOnline = false;
            }
            if (obj && obj.offlineSalarySettlement) {
              // 有线下课
              this.hasOffline = true;
              this.offlineSalary =
                obj.offlineSalarySettlement.salarySettlementType;
              // console.log('线下:' + this.offlineSalary)
            } else {
              this.hasOffline = false;
            }
          }
        }
      }
    },
    // 点击确插入课表
    addWeek () {
      let courseType = this.maskForm.type;
      // let week = ;this.maskForm.week
      let startTime = this.maskForm.startTime;
      if (!courseType || !this.maskForm.week || !startTime) {
        this.$message.error("请填写完成信息");
        return;
      }
      // 拿到相应的值插入数组
      let endTime = this.MinutesTest(startTime, this.leftForm.classTime);

      let str;
      switch (courseType) {
        case "ONLINE":
          {
            str = "线上课";
            break;
          }
        case "OFFLINE":
          {
            str = "线下课";
            break;
          }
      }
      let flag = false;
      for (let i in this.lookList) {
        if (this.lookList[i].weekDay == this.maskForm.week) {
          flag = true;
        }
      }
      // true=> 说明有这一周 那么循环找到这一周 在判断时间
      // flase=> 说明没有这一周的时间 直接添加
      if (flag) {
        // 有相同的周日
        let arr = [];
        for (let i in this.lookList) {
          if (this.lookList[i].weekDay == this.maskForm.week) {
            // 找到这一天的所有元素
            //  && !this.timeIsrange(this.lookList[i].startTime, this.lookList[i].endTime, startTime) && !this.timeIsrange(this.lookList[i].startTime, this.lookList[i].endTime, endTime)
            let isStartTime = this.timeIsrange(
              startTime,
              endTime,
              this.lookList[i].startTime
            );
            let isEndTime = this.timeIsrange(
              startTime,
              endTime,
              this.lookList[i].endTime
            );
            arr.push(!isEndTime && !isStartTime);
          }
        }
        let isAdd = true;
        for (let j = 0; j < arr.length; j++) {
          isAdd = isAdd && arr[j];
        }
        if (isAdd) {
          this.lookList.push({
            type: str,
            week: this.weekDay[this.maskForm.week],
            weekDay: this.maskForm.week,
            startTime: startTime,
            endTime: endTime,
            time: startTime + "-" + endTime,
            id: Date.now()
          });
        } else {
          this.$message.error("该时间段已排课请重选时间");
          return;
        }
      } else {
        this.lookList.push({
          type: str,
          week: this.weekDay[this.maskForm.week],
          weekDay: this.maskForm.week,
          startTime: startTime,
          endTime: endTime,
          time: startTime + "-" + endTime,
          id: Date.now()
        });
      }
      // console.log(this.lookList)
      // let courseType = this.maskForm.type;
      // // let week = ;this.maskForm.week
      // let startTime = this.maskForm.startTime;
      this.maskForm.type = "";
      this.maskForm.week = "";
      this.maskForm.startTime = "";
      this.maskForm.endTime = ""
    },
    // 分钟小时相加减
    MinutesTest (str, interval) {
      let houer = str.split(":")[0];
      let min = str.split(":")[1];
      let sdate1 = new Date(1900, 1, 1, houer, min);
      sdate1.setMinutes(sdate1.getMinutes() + parseInt(interval));
      let H = sdate1.getHours();
      let M = sdate1.getMinutes();
      if (H < 10) H = "0" + H;
      if (M < 10) M = "0" + M;
      return H + ":" + M;
    },
    // 判断时间是否在时间段内
    timeIsrange (beginTime, endTime, nowTime) {
      var strb = beginTime.split(":");
      if (strb.length != 2) {
        return false;
      }
      var stre = endTime.split(":");
      if (stre.length != 2) {
        return false;
      }
      var strn = nowTime.split(":");
      if (stre.length != 2) {
        return false;
      }
      var b = new Date();
      var e = new Date();
      var n = new Date();
      b.setHours(strb[0]);
      b.setMinutes(strb[1]);
      e.setHours(stre[0]);
      e.setMinutes(stre[1]);
      n.setHours(strn[0]);
      n.setMinutes(strn[1]);

      if (n.getTime() - b.getTime() >= 0 && n.getTime() - e.getTime() <= 0) {
        // 在时间范围内
        return true;
      } else {
        // 不在时间范围内
        return false;
      }
    },
    removeWeekCourse (id) {
      for (let i in this.lookList) {
        if (this.lookList[i].id == id) {
          this.lookList.splice(i, 1);
        }
      }
    },
    setTimeTable () {
      // 拿到线上课数与线下课数 以及
      this.timeTable = [];
      let online = parseInt(this.centerForm.onlineCourseNum) || 0;
      let offline = parseInt(this.centerForm.offlineCourseNum) || 0;

      let giveNum = this.giveNum;
      let giveClassType = this.centerForm.radio;
      if (giveClassType == "ONLINE") {
        // 线上
        online += giveNum;
      } else if (giveClassType == "OFFLINE") {
        offline += giveNum;
      }

      // 这里判断是否选择了排课开始时间
      if (online && !this.maskForm.courseStartOnline) {
        this.$message.error("选择了线上课 但没有线上课开始时间");
        return;
      }

      if (offline && !this.maskForm.courseStartOffline) {
        this.$message.error("选择了线下课 但没有线下课开始时间");
        return;
      }
      let date, date1;
      if (this.maskForm.courseStartOnline) {
        date = new Date(this.maskForm.courseStartOnline.getTime());
      }
      if (this.maskForm.courseStartOffline) {
        date1 = new Date(this.maskForm.courseStartOffline.getTime());
      }
      // let startWeekday = this.maskForm.courseStart.getDay();
      let onlineList = []; // 装线上课的数组
      let offlineList = []; //装线下课的数组
      if (this.lookList.length <= 0) {
        this.$message.error("请先排课后再点击确认按钮");
        return;
      }

      for (let i in this.lookList) {
        if (this.lookList[i].type == "线上课") {
          onlineList.push({
            week: this.lookList[i].weekDay,
            date: this.lookList[i]
          });
        }
        if (this.lookList[i].type == "线下课") {
          offlineList.push({
            week: this.lookList[i].weekDay,
            date: this.lookList[i]
          });
        }
      }
      // console.log(onlineList + '----------------------------------------------------------------------------------');
      // console.log(offlineList);

      if (online > 0 && onlineList.length <= 0) {
        this.$message.error("选择了线上课但未排线上课");
        this.timeTable = [];
        return;
      }
      if (offline > 0 && offlineList.length <= 0) {
        this.$message.error("选择了线下课但未排线下课");
        this.timeTable = [];
        return;
      }

      // 获取要排课的总数  获取每周要排多少次
      while (online && online > 0) {
        // 排线上课g
        for (let i in onlineList) {
          let num;
          onlineList[i].week - date.getDay() >= 0 ?
            (num = onlineList[i].week - date.getDay()) :
            (num = onlineList[i].week - date.getDay() + 7); // +差值的天数://差值的天数+7
          // console.log(num);
          let dataStr = this.getThinkDate(date, num);
          this.timeTable.push({
            classDate: dataStr + " 00:00:00",
            actualTeacherId: this.leftForm.teacher,
            startClassTimeStr: onlineList[i].date.startTime,
            endClassTimeStr: onlineList[i].date.endTime,
            teachMode: "ONLINE"
          });
          online--;
          if (online == 0) break;
        }
        if (onlineList.length == 1 || this.isAllEqual(onlineList)) {
          date.setDate(date.getDate() + 7);
        }

        // 加一周
      }

      // console.log(date1)
      while (offline && offline > 0) {
        // 排线下课
        for (let i in offlineList) {
          let num;
          offlineList[i].week - date1.getDay() >= 0 ?
            (num = offlineList[i].week - date1.getDay()) :
            (num = offlineList[i].week - date1.getDay() + 7); // +差值的天数://差值的天数+7
          let dataStr = this.getThinkDate(date1, num);
          this.timeTable.push({
            classDate: dataStr + " 00:00:00",
            actualTeacherId: this.leftForm.teacher,
            startClassTimeStr: offlineList[i].date.startTime,
            endClassTimeStr: offlineList[i].date.endTime,
            teachMode: "OFFLINE"
          });
          offline--;
          if (offline == 0) break;
        }
        // 加一周
        if (offlineList.length == 1 || this.isAllEqual(offlineList)) {
          date1.setDate(date1.getDate() + 7);
        }
      }
      // console.log(this.timeTable);
      this.dialogFormVisible = false;
    },
    getThinkDate (date, num) {
      let Stamp = date;
      Stamp.setDate(date.getDate() + num); // 获取当前月数的第几天
      // console.log(date.getMonth() + 1)
      // console.log(Stamp.getMonth() + 1)
      var year = Stamp.getFullYear(); //获取完整的年份(4位,1970-????)
      var month = Stamp.getMonth() + 1; //获取当前月份(0-11,0代表1月)
      var mvar = "";
      if (month < 10) {
        mvar = "0" + month;
      } else {
        mvar = month + "";
      }
      var day = Stamp.getDate();
      var dvar = "";
      if (day < 10) {
        dvar = "0" + day;
      } else {
        dvar = day + "";
      }
      // console.log(year + "-" + mvar + '-' + dvar);
      return year + "-" + mvar + "-" + dvar;
    },
    // 计算课酬
    computational () {
      this.computationalBtn = true;
      let userId = this.leftForm.teacher || null;
      let giveTeachMode = this.centerForm.radio || null;
      let vipGroupCategoryId = this.leftForm.courseType || null;
      let vipGroupActivityId = this.leftForm.activeType || null;
      let onlineClassesUnitPrice = this.rightForm.onlinePrice || null;
      let offlineClassesUnitPrice = this.rightForm.offlinePrice || null;
      let onlineClassesNum = this.centerForm.onlineCourseNum || 0;
      let offlineClassesNum = this.centerForm.offlineCourseNum || 0;
      let singleClassMinutes = this.leftForm.classTime;
      if (this.hotType == "GIVE_CLASS") {
        if (this.centerForm.radio == "ONLINE") {
          onlineClassesNum =
            parseInt(onlineClassesNum) + parseInt(this.giveNum);
        } else if (this.centerForm.radio == "OFFLINE") {
          offlineClassesNum =
            parseInt(offlineClassesNum) + parseInt(this.giveNum);
        }
      }
      let onlineTeacherSalary = this.rightForm.onlineCourse || null;
      let offlineTeacherSalary = this.rightForm.offlineCourse || null;
      getVipGroupCostCount({
        vipGroupActivityId,
        onlineClassesUnitPrice,
        onlineTeacherSalary,
        offlineTeacherSalary,
        vipGroupCategoryId,
        offlineClassesUnitPrice,
        onlineClassesNum,
        offlineClassesNum,
        userId,
        giveTeachMode,
        singleClassMinutes
      }).then(res => {
        if (res.code == 200) {
          this.rightForm.onlineCourse = res.data.onlineTeacherSalary;
          this.rightForm.offlineCourse = res.data.offlineTeacherSalary;
          this.rightForm.allPrice = res.data.totalPrice;
        }
      });
    },
    isAllEqual (array) {
      if (array.length > 0) {
        return !array.some((val, index) => {
          return val.week != array[0].week;
        });
      } else {
        return true;
      }
    },
    submitInfo () {
      if (!this.computationalBtn) {
        this.$message.error("请点击计算按钮计算课酬");
        return;
      }
      if (this.leftForm.students.length !== this.studentLimit) {
        this.$message.error(`请选择上课学生为${this.studentLimit}人`)
        return;
      }
      // 判断线上课课酬和线下课课酬
      let online = parseInt(this.centerForm.onlineCourseNum);
      let offline = parseInt(this.centerForm.offlineCourseNum);

      let giveNum = this.giveNum;
      let giveClassType = this.centerForm.radio;
      if (giveClassType == "ONLINE") {
        // 线上
        online += giveNum;
      } else if (giveClassType == "OFFLINE") {
        offline += giveNum;
      }
      let obj = {};
      obj.courseSchedules = this.timeTable;
      /**
       *
       * teacher: '',
        subject: '',
        courseType: '',
        activeType: '',
        classNum: '',
        classTime: '',
        signUpStart: '',
        signUpEnd: '',
        courseStart: '',
        courseEnd: ''
       */
      let studentIdList = this.leftForm.students.join(",") || null;
      obj.vipGroupApplyBaseInfo = {
        studentIdList,
        coursesExpireDate: this.leftForm.courseEnd,
        teacherSchoolId: this.leftForm.section,
        // name: this.leftForm.name,
        offlineClassesNum: offline || 0,
        onlineClassesNum: online || 0,
        offlineClassesUnitPrice: this.rightForm.offlinePrice || 0,
        onlineClassesUnitPrice: this.rightForm.onlinePrice || 0,
        paymentExpireDate: this.leftForm.signUpEnd,
        registrationStartTime: this.leftForm.signUpStart,
        singleClassMinutes: this.leftForm.classTime,
        studentNum: this.leftForm.classNum,
        userId: this.leftForm.teacher,
        vipGroupActivityId: this.leftForm.activeType,
        vipGroupCategoryId: this.leftForm.courseType,
        onlineTeacherSalary: this.rightForm.onlineCourse || 0,
        offlineTeacherSalary: this.rightForm.offlineCourse || 0,
        giveTeachMode: this.centerForm.radio,
        subjectIdList: this.leftForm.subject,
        educationalTeacherId: this.leftForm.educationalTeacherId,
        organId: this.leftForm.classOrganId
      };

      // 调接前判断是新增还是修改
      if (!this.id) {
        // 新增
        createVip(obj).then(res => {
          if (res.code == 200) {
            if (res.data == "ING") {
              this.$confirm(
                "课程提交成功，已提交运营主管审批,审批通过后，课程后创建成功！",
                "提示", {
                confirmButtonText: "确定",
                type: "warning"
              }
              ).then(() => {
                // this.$message({
                //   type: 'success',
                //   message: '提交成功!'
                // });
                this.$message.success("提交成功");
                this.$router.push({
                  path: "/business/vipList",
                  query: {
                    rules: this.rules,
                    searchForm: this.searchForm
                  }
                });
              });
            } else {
              this.$message.success("恭喜您创建成功");
              this.$router.push({
                path: "/business/vipList",
                query: {
                  rules: this.rules,
                  searchForm: this.searchForm
                }
              });
            }
          }
        });
      } else {
        // 修改
        obj.vipGroupApplyBaseInfo.id = this.id;
        updateVipBaseInfo(obj.vipGroupApplyBaseInfo).then(res => { });
      }
    },
    setSection (val) {
      this.leftForm.section = "";
      this.rightForm.offlineCourse = "";
      this.rightForm.onlineCourse = "";
      this.leftForm.courseType = "";
      if (val) {
        getTeachSchool({
          userId: val
        }).then(res => {
          if (res.code == 200) {
            this.scetionList = res.data;
          }
        });
      }
      // for (let i in this.teacherList) {
      //   if (this.teacherList[i].id == val) {
      //     // 根据分部id去获取课程形式
      //     vipGroupCategory({ organId: this.teacherList[i].organId }).then(
      //       res => {
      //         if (res.code == 200) {
      //           this.courseTypeList = res.data;
      //         }
      //       }
      //     );
      //   }
      // }
      this.getClassOrgan() // 获取公用部分
    },
    getClassOrgan () { // 获取公用分部
      const leftForm = this.leftForm
      let teacher = leftForm.teacher ? leftForm.teacher : null
      let educationalTeacherId = leftForm.educationalTeacherId ? leftForm.educationalTeacherId : null
      leftForm.classOrganId = null // 重置课程分部数据
      this.classOrganList = []
      // 初始化上课学生
      this.studentList = []
      this.leftForm.students = []
      if (!teacher || !educationalTeacherId) { // 如果没有选择指导老师和乐团主管则不请求
        return
      }
      getPublicOrgans({
        teacherId: teacher,
        eduTeacherId: educationalTeacherId
      }).then(res => {
        if (res.code == 200) {
          let result = res.data ? res.data : []
          this.classOrganList = result
        }
      })
    },
    onClassChange (val) { // 课程分部改变时
      this.studentList = []
      this.leftForm.students = []

      this.courseTypeList = []
      this.leftForm.courseType = null
      if (val) {
        vipGroupCategory({
          organId: val
        }).then(
          res => {
            if (res.code == 200) {
              this.courseTypeList = res.data;
            }
          }
        )
      }
    },
    onCancel () {
      this.$router.push({
        path: "/business/vipList",
        query: {
          rules: this.rules,
          searchForm: this.searchForm
        }
      });
    },
    setCourse () {
      if (
        this.hotType == "GIVE_CLASS" &&
        this.isGiveClass &&
        !this.centerForm.radio
      ) {
        this.$message.error("您还未选择赠课类型");
        return;
      }
      this.$refs["leftForm"].validate(vali => {
        if (vali) {
          this.dialogFormVisible = true;
        }
      });
    },
    setVipInfo (data) {
      // this.leftForm.name = data.name;
      this.leftForm.subject = parseInt(data.subjectIdList);
      // 激活声部下的所有老师
      this.changeSubject(parseInt(data.subjectIdList));
      // 设置老师
      this.leftForm.teacher = data.userId;
      this.setSection(data.userId);
      // 课程形式
      this.leftForm.courseType = data.vipGroupCategoryId;
      // 获取课程形式下的活动方案
      this.changeType(this.leftForm.courseType);
      // 根据课程形式获取活动方案
      this.leftForm.activeType = data.vipGroupActivityId;
      setTimeout(res => {
        this.chioseActive(data.vipGroupActivityId);
      }, 1000);

      this.leftForm.section = data.teacherSchoolId;
      this.leftForm.classNum = data.studentNum;
      this.leftForm.classTime = data.singleClassMinutes;
      this.leftForm.signUpStart = data.registrationStartTime;
      this.leftForm.signUpEnd = data.paymentExpireDate;
      this.centerForm.onlineCourseNum = data.onlineClassesNum;
      this.centerForm.offlineCourseNum = data.offlineCourseNum;
      /**
       *   rightForm: {
        onlineCourse: '',
        offlineCourse: '',
        onlinePrice: '',
        offlinePrice: '',
        allPrice: ''
      },
       *
       */
      this.rightForm.onlineCourse = data.onlineTeacherSalary;
      this.rightForm.onlinePrice = data.onlineClassesUnitPrice;
      this.rightForm.offlineCourse = data.offlineTeacherSalary;
      this.rightForm.offlinePrice = data.offlineClassesUnitPrice;
      this.rightForm.allPrice = data.totalPrice;

      //subjectIdList
    },
    remoteMethod (query) {
      if (query !== "") {
        this.remoteLoading = true;
        // 发请求搜索
        const url = "/api-web/studentManage/queryOrganStudentList"
        const options = {
          method: "get",
          headers: {
            Authorization: getToken()
          },
          params: {
            rows: 9999,
            search: query,
            organId: this.leftForm.classOrganId
          },
          url
        }
        this.remoteLoading = true
        // this.studentList = []
        axios(options).then(res => {
          this.remoteLoading = false
          let result = res.data
          if (result.code == 200) {
            // Array.prototype.splice.apply(this.studentList, result.data.rows);
            if (result.data.rows && result.data.rows.length > 0) {
              result.data.rows.forEach(item => {
                this.studentList.unshift(item)
              })
              this.studentList = this.deweight(this.studentList, "userId");
            }
            // this.studentList = this.studentList.concat(result.data.rows);

          }
        })
        // queryStudentList({ rows: 100, search: query }).then(res => {
        //   if (res.code == 200) {
        //     this.remoteLoading = false;
        //     this.studentList = this.studentList.concat(res.data.rows);
        //     this.unique(this.studentList, "userId");
        //   }
        // });
      }
    },
    // 制定属性去重
    deweight (arr, key) {
      let res = []
      arr.forEach((item) => {
        let list = []
        res.forEach((resitem) => {
          list.push(resitem[key])
        })
        if (list.indexOf(item[key]) === -1) {
          res.push(item)
        }
      })
      return res
    },
    getStartTime (val) {
      if (val) {
        let date = dayjs(new Date()).format('YYYY-MM-DD')
        this.maskForm.endTime = addTimerFormMinute(date, val, this.leftForm.classTime);
      } else {
        this.maskForm.endTime = ''
      }
      if (!this.maskForm.endTime) {
        this.maskForm.startTime = ''
      }
    }
  }
  // watch: {
  //   rightForm: {
  //     handler (newName, oldName) {
  //       this.computationalBtn = false
  //     },
  //     deep: true
  //   }
  // }
};
</script>
<style lang="scss" scoped>
.m-core {
  margin-top: 30px;
  display: flex;
  flex-direction: row;
  justify-content: space-around;

  .el-input {
    width: 180px;
  }

  h4 {
    font-size: 16px;
    background-color: #ccc;
    color: #fff;
    text-align: center;
    width: 100%;
    height: 40px;
    line-height: 40px;
    margin-bottom: 20px;
  }

  .vipLeft {
    width: 400px;
    // h4 {
    //   font-size: 16px;
    //   background-color: #ccc;
    //   color: #fff;
    //   text-align: center;
    //   width: 100%;
    //   height: 40px;
    //   line-height: 40px;
    //   margin-bottom: 20px;
    // }
  }

  .center {
    width: 400px;
  }

  .right {
    width: 400px;
  }
}

.planList {
  padding: 0 25px;

  .planTop {
    height: 40px;
    line-height: 40px;
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    border-bottom: 1px solid #ccc;
    margin-top: 20px;

    > p {
      font-size: 14px;
    }
  }

  .planCore {
    .row {
      width: 100%;
      display: flex;
      flex-direction: row;
      justify-content: space-between;
      flex-wrap: nowrap;
      height: 40px;
      line-height: 40px;
      font-size: 14px;
      text-align: center;

      div {
        width: 87px;
      }

      // div {
      //   &:nth-child(1) {
      //     text-align: left;
      //   }
      // }
    }
  }
}

.okBtn {
  width: 120px;
  height: 40px;
  line-height: 40px;
  text-align: center;
  color: #fff;
  border-radius: 4px;
  margin-right: 20px;
  cursor: pointer;
  background-color: #f97215;
  float: right;
}
</style>
